#include <stdlib.h>
#include <math.h>
#include <SDL.h>

SDL_Surface *USB_fb;

#include "fractal.raw"

void set_pixel(int x, int y)
{
   if (x > 0 && y > 0)
   	 ((Uint32*)USB_fb->pixels)[((y-1)*800) + (x-1)] = 0x000000;
}

void render()
{

   if (SDL_MUSTLOCK(USB_fb)) 
   if (SDL_LockSurface(USB_fb) < 0)
   	 return;

   unsigned int line = 0;
   unsigned int pxl_offset;

/* 
   for (line = 0; line < 480; line++)
   {
   	 for (pxl_offset = 0; pxl_offset < 640; pxl_offset++)
   	 {
        ((unsigned long*)screen->pixels)[(line*640) + pxl_offset] = pxl_offset / 3;
   	 }
   }
*/

   if (SDL_MUSTLOCK(USB_fb)) 
   	 SDL_UnlockSurface(USB_fb);

   /* update screen */
   SDL_UpdateRect(USB_fb, 0, 0, 800, 480);
   
   for (line = 0; line < 480; line++)
   {
   	 for (pxl_offset = 0; pxl_offset < 800; pxl_offset++)
   	 {
        ((Uint32*)USB_fb->pixels)[(line*800) + pxl_offset] = 0xffffff;
   	 }
   }
}

int main(int argc, char *argv[])
{   
   unsigned int i,line,x_offset;
   Uint32 raw_pixel;

  /* Initialize video */
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) 
  {
    fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }

  atexit(SDL_Quit);
    
  /* Attempt to create a 800x480 window with 24bit per pixels. */
  USB_fb = SDL_SetVideoMode(800, 480, 32, SDL_SWSURFACE);

  if ( USB_fb == NULL )
  {
    fprintf(stderr, "Unable to set 800x480 video: %s\n", SDL_GetError());
    exit(1);
  }

  SDL_WM_SetCaption ("USB fb emulator v0.1a", NULL);

  while (1)
  {
   x_offset = 80;

   for(line=0; line<480; line++)
   {
      for(i=0; i<(640*3); i+=3)
      {
         raw_pixel = 0;

         raw_pixel |= (((Uint32)picture_dat[(line*640*3)+i]) & 0xf8) << 16;
         raw_pixel |= (((Uint32)picture_dat[(line*640*3)+i+1]) & 0xfc) << 8;
         raw_pixel |= (((Uint32)picture_dat[(line*640*3)+i+2]) & 0xf8);

         //printf(">>%x, %x", raw_pixel, 0x02);

         ((Uint32*)USB_fb->pixels)[(line*800) + x_offset + (i/3)] = raw_pixel;
      }
   }

   render();

    SDL_Event event;
    while (SDL_PollEvent(&event)) 
    {
      switch (event.type) 
      {
      case SDL_KEYDOWN:
        break;
      case SDL_KEYUP:
        if (event.key.keysym.sym == SDLK_ESCAPE)
          return 0;
        break;
      case SDL_QUIT:
        return(0);
      }
    }
  }
  return 0;
}
